//
//    ******************************
//    *                            *
//    *    RunAction.hh     *
//    *                            *
//    ******************************

#ifndef RunAction_h
#define RunAction_h 1

#include "G4UserRunAction.hh"
#include <sstream>
#include "DetectorConstruction.hh"

class G4Run;



class RunAction : public G4UserRunAction
{
 public:
 
  RunAction();
  ~RunAction();

 // void BeginOfRunAction(const G4Run*);
  void EndOfRunAction(const G4Run*);

  void AddTotalEnergy(G4double Edep)
       {
	TotalE += Edep;
        if(Edep>Emax)Emax=Edep;
	}

 void AddDoseProfile(G4double Einc, G4int CopyNo, G4int RingNo)
       {
	
 
                depthHisto[CopyNo*8 + (RingNo-1)] += Einc;
       }


void AddIncidentSpectra(G4double Einc, G4bool Beta)
       {
        G4int Eint= int(Einc/keV/10.);
	if(Beta)BSpectra[Eint]++;
        else XSpectra[Eint]++;
       // G4cout<<"test spectre"<<G4endl;
       }

 
       

 private:

  std::vector <G4int> XSpectra;
  std::vector <G4int> BSpectra;
  std::vector <G4double> depthHisto; 
  G4double TotalE, Emax;
G4float size;
G4float resolution;
G4int NbPixel;

 G4int depthCat;
 G4int spreadCat;
 G4int spectrumCat;
 G4double mass_div[8];

};

#endif
