//
//    ******************************
//    *                            *
//    *    RunAction.cc     *
//    *                            *
//    ******************************

#include "RunAction.hh"
#include "G4Run.hh"

using namespace std;

RunAction::RunAction()
{
TotalE = 0.;
 Emax =0.;
 G4int N_ring = 8;
 G4int N_Layer=int(Sample_Thick/Sample_div);
 depthCat=N_Layer*N_ring ;
 depthHisto.reserve(depthCat);
 for(G4int i=0;i<depthCat;i++)depthHisto[i]=0.;
 spectrumCat = 250;
 BSpectra.reserve(spectrumCat);XSpectra.reserve(spectrumCat);
 for(G4int i=0;i<spectrumCat;i++){XSpectra[i]=0;BSpectra[i]=0;}
}

RunAction::~RunAction(){;}

void RunAction::EndOfRunAction(const G4Run*)
{  
 G4cout<<G4endl<<"totalEdeposit(keV) = "<<TotalE/keV<<G4endl;
 G4cout<<"maxEdeposit(keV) = "<<Emax/keV<<G4endl;

 ofstream Histo;
 G4String HistoName = result+"_Depth.txt";
 remove(HistoName);
 Histo.open(HistoName, ios::out|ios::app);

 G4int N_ring = 8;
 G4int N_Layer=int(Sample_Thick/Sample_div);
 for(G4int i=0;i<N_ring-1;i++)mass_div[i]=Sample_densi*Sample_div*M_PI*(pow((i+1)*1.*mm/2.,2.) - pow(i*1.*mm/2.,2.));
 mass_div[N_ring-1]=Sample_densi*Sample_div*M_PI*(pow(Sample_diam/2.,2.)-pow(7.*mm/2.,2.));

 for(G4int i=0;i<N_ring-1;i++)G4cout<< mass_div[i]/g<<G4endl;
 
 Histo<<"depth(mm) DoseR1(mGray) DoseR2(mGray)  DoseR3(mGray) DoseR4(mGray) DoseR5(mGray) DoseR6(mGray) DoseR7(mGray) DoseR8(mGray)"<<G4endl;
 for(G4int i=0;i<N_Layer;i++)
 {
  Histo<<(i+0.5)*Sample_div/mm;
  for(G4int j=0;j<N_ring;j++)Histo<<" "<<depthHisto[i*N_ring+j]/mass_div[j]*1000./gray;
  Histo<<G4endl;
 }

 Histo.close();

 ofstream Specta;
 G4String SpectaName = result+"_Spectra.txt";
 remove(SpectaName);
 Specta.open(SpectaName, ios::out|ios::app);
 
 Specta<<"Energy(keV) Beta Xray"<<G4endl;
 for(G4int i=0;i<spectrumCat;i++)Specta<<(i+0.5)*10<<" "<<BSpectra[i]<<" "<<XSpectra[i]<<G4endl;

 Specta.close();
}


