//
// ********************************************************************
// * License and Disclaimer                                           *
// *                                                                  *
// * The  Geant4 software  is  copyright of the Copyright Holders  of *
// * the Geant4 Collaboration.  It is provided  under  the terms  and *
// * conditions of the Geant4 Software License,  included in the file *
// * LICENSE and available at  http://cern.ch/geant4/license .  These *
// * include a list of copyright holders.                             *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.  Please see the license in the file  LICENSE  and URL above *
// * for the full disclaimer and the limitation of liability.         *
// *                                                                  *
// * This  code  implementation is the result of  the  scientific and *
// * technical work of the GEANT4 collaboration.                      *
// * By using,  copying,  modifying or  distributing the software (or *
// * any work based  on the software)  you  agree  to acknowledge its *
// * use  in  resulting  scientific  publications,  and indicate your *
// * acceptance of all terms of the Geant4 Software license.          *
// ********************************************************************
//

#include "SteppingAction.hh"

//#include "G4TrackVector.hh"

using namespace std;

SteppingAction::SteppingAction(RunAction* run)
:RunAct(run)
{
 security = 0;
 VoxelSafety = true;
}

SteppingAction::~SteppingAction()
{;}

void SteppingAction::UserSteppingAction(const G4Step* step)
{
 PreStep = step->GetPreStepPoint();
 PostStep = step->GetPostStepPoint();
 G4double Edep = step->GetTotalEnergyDeposit();

  if((PreStep->GetPhysicalVolume()->GetName()=="sample_div_1")&&(Edep >0.*keV))
 {
  RunAct->AddTotalEnergy(Edep);
  RunAct->AddDoseProfile(Edep, PreStep->GetPhysicalVolume()->GetCopyNo (), 1);
 }
 else if((PreStep->GetPhysicalVolume()->GetName()=="sample_div_2")&&(Edep >0.*keV))
 {
  RunAct->AddTotalEnergy(Edep);
  RunAct->AddDoseProfile(Edep, PreStep->GetPhysicalVolume()->GetCopyNo (), 2);
 }
 else if((PreStep->GetPhysicalVolume()->GetName()=="sample_div_3")&&(Edep >0.*keV))
 {
  RunAct->AddTotalEnergy(Edep);
  RunAct->AddDoseProfile(Edep, PreStep->GetPhysicalVolume()->GetCopyNo (), 3);
 }
 else if((PreStep->GetPhysicalVolume()->GetName()=="sample_div_4")&&(Edep >0.*keV))
 {
  RunAct->AddTotalEnergy(Edep);
  RunAct->AddDoseProfile(Edep, PreStep->GetPhysicalVolume()->GetCopyNo (), 4);
 }
 else if((PreStep->GetPhysicalVolume()->GetName()=="sample_div_5")&&(Edep >0.*keV))
 {
  RunAct->AddTotalEnergy(Edep);
  RunAct->AddDoseProfile(Edep, PreStep->GetPhysicalVolume()->GetCopyNo (), 5);
 }
 else if((PreStep->GetPhysicalVolume()->GetName()=="sample_div_6")&&(Edep >0.*keV))
 {
  RunAct->AddTotalEnergy(Edep);
  RunAct->AddDoseProfile(Edep, PreStep->GetPhysicalVolume()->GetCopyNo (), 6);
 }
 else if((PreStep->GetPhysicalVolume()->GetName()=="sample_div_7")&&(Edep >0.*keV))
 {
  RunAct->AddTotalEnergy(Edep);
  RunAct->AddDoseProfile(Edep, PreStep->GetPhysicalVolume()->GetCopyNo (), 7);
 }
 else if((PreStep->GetPhysicalVolume()->GetName()=="sample_div_8")&&(Edep >0.*keV))
 {
  RunAct->AddTotalEnergy(Edep);
  RunAct->AddDoseProfile(Edep, PreStep->GetPhysicalVolume()->GetCopyNo (), 8);
 }

}
 

